package gfmq.ejb;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.annotation.Resource;
import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.inject.Inject;
import javax.jms.ConnectionFactory;
import javax.jms.JMSConnectionFactory;
import javax.jms.JMSContext;
import javax.jms.JMSSessionMode;
import javax.jms.Queue;

@Stateless
@LocalBean
public class Producer_EJB {

    @Inject
    // @JMSConnectionFactory("java:app/jms/ontheflyConnectionFactory")
    @JMSConnectionFactory("jms/denemeConnectionFactory")
    @JMSSessionMode(JMSContext.AUTO_ACKNOWLEDGE)
    private JMSContext jmsContext;

    // @Resource(lookup = "java:app/jms/denemeConnectionFactory")
    // ConnectionFactory connectionFactory;

    // @Resource(lookup = "java:app/jms/ontheflyQueue")
    @Resource(lookup = "jms/denemeQueue")
    private Queue queue;

    @PostConstruct
    public void postConstruct() {
	System.out.println("Producer_EJB postConstruct OK");
	sendMessage("Deneme text mesaji Producer_EJB den gonderildi.");
    }

    @PreDestroy
    public void preDestroy() {
	System.out.println("Producer_EJB preDestroy OK");
    }

    public Producer_EJB() {
    }

    public void sendMessage(String payload) {
	jmsContext.createProducer().send(queue, payload);
	System.out
		.println("Producer_EJB Mesaj gonderildi! payload: " + payload);
    }

}
